
#include <SPI.h>
#include <Wire.h>                
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>

#define OLED_RESET 16


#define SERVICE_UUID           "6E400001-B5A3-F393-E0A9-E50E24DCCA9E" // UART service UUID
#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9E"
#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9E"

//BLECharacteristic *pCharacteristic  ;
BLECharacteristic *pCharacteristic;
bool deviceConnected = false;
float txValue = 0;

Adafruit_SSD1306 display(OLED_RESET);

const int pingPin = 19; //D19
int inPin = 18; //D18
int led = 23; //D23
int buzzer = 5 ; // D5
long duration, cm;

String stringOne , stringTwo;

class MyServerCallbacks: public BLEServerCallbacks {
    void onConnect(BLEServer* pServer) {
      deviceConnected = true;
    };

    void onDisconnect(BLEServer* pServer) {
      deviceConnected = false;
    }
};


void setup() {
  Wire.begin(); 
  Serial.begin(115200);
  pinMode(led, OUTPUT);
  pinMode(buzzer, OUTPUT);
  digitalWrite(led, HIGH);   
  display.begin(SSD1306_SWITCHCAPVCC, 0x3c);  
  Serial.println("Starting PRJ!");

  BLEDevice::init("Tangk & Na Project");
  BLEServer *pServer = BLEDevice::createServer();
  pServer->setCallbacks(new MyServerCallbacks());
  BLEService *pService = pServer->createService(SERVICE_UUID);
  pCharacteristic = pService->createCharacteristic(
                      CHARACTERISTIC_UUID_TX,
                      BLECharacteristic::PROPERTY_NOTIFY
                    );
  pCharacteristic->addDescriptor(new BLE2902());

  BLECharacteristic *pCharacteristic = pService->createCharacteristic(
                                         CHARACTERISTIC_UUID_RX,
                                         BLECharacteristic::PROPERTY_WRITE
                                       );
//  pCharacteristic->setCallbacks(new MyCallbacks());

  // Start the service
  pService->start();

  // Start advertising
  pServer->getAdvertising()->start();
  Serial.println("Waiting a client connection to notify...");
}
void displayCM() {
  
  display.clearDisplay();
  display.setTextSize(1); // กำหนดขนาดตัวอักษร
  display.setTextColor(WHITE);
  display.setCursor(0,0); // กำหนดตำแหน่ง x,y ที่จะแสดงผล
  display.print("State is  ");
  display.print(stringOne);
  display.println("");
  display.setCursor(0,10); 
  display.setTextSize(2);
  display.setTextColor(BLACK, WHITE);
  display.print("RANGE: ");
  display.print(cm);
  display.display();
}
  long microsecondsToCentimeters(long microseconds)
{

return microseconds / 29 / 2;
}
void OnState() {
    pinMode(pingPin, OUTPUT);
    digitalWrite(pingPin, LOW);
    delayMicroseconds(2);
    digitalWrite(pingPin, HIGH);
    delayMicroseconds(5);
    digitalWrite(pingPin, LOW);
    pinMode(inPin, INPUT);
    duration = pulseIn(inPin, HIGH);
     
    cm = microsecondsToCentimeters(duration);
}
long int Fuck(void)
{

return (cm);
}
void loop()
{
  Wire.requestFrom(0x50, 3);  
  while (Wire.available()) {
    stringTwo = "ON ";
    stringOne = "" ;
    for(int i =0 ; i <3 ; i++ ) {
      char c = Wire.read(); 
      stringOne += c ;
     }
    Serial.println(stringOne);
    if ( stringOne.equals(stringTwo)) {
      OnState();
    }
    else {
      cm = 0 ;
      }
    if (cm >= 15 && cm != 0) {
      digitalWrite(led, HIGH);
      digitalWrite(buzzer, LOW);
    }
    else {
      digitalWrite(led, LOW);
      
      digitalWrite(buzzer, HIGH);
    }
    displayCM();
//    std::string myStringForUnit16((char*)&cm, 4);
    std::string  CM((char*)&cm );
    pCharacteristic->setValue(CM);
    
  }
  delay(500);
}
